###########################################################
#                Tcl/Tk Project Manager                   #
#                Distrubuted under GPL                    #
# Copyright (c) "CONERO lab", 2002, http://conero.lrn.ru  #
# Author: Sergey Kalinin (aka BanZaj) banzaj@lrn.ru       #
###########################################################

Modules
## MAIN INTERFACE ##
wm geometry . 630x470+0+0
wm title . "Tcl/Tk Project Manager $ver"
wm iconname . "Tcl/Tk Project Manager $ver"
wm protocol . WM_DELETE_WINDOW Quit
wm overrideredirect . 0
wm positionfrom . user
#wm resizable . 0 0

frame .frmMenu -border 1 -relief raised
frame .frmTool -border 1 -relief raised
frame .frmBody -border 1 -relief raised
frame .frmStatus -border 1 -relief sunken
pack .frmMenu -side top -padx 1 -fill x
pack .frmTool -side top -padx 1 -fill x
pack .frmBody -side top -padx 1 -fill both -expand true
pack .frmStatus -side top -padx 1 -fill x

########## CREATE MENU LINE ##########
menubutton .frmMenu.mnuFile -text [::msgcat::mc "File"] -menu .frmMenu.mnuFile.m -font $fontNormal
set m [menu .frmMenu.mnuFile.m]
$m add cascade -label [::msgcat::mc "New"] -menu $m.new -font $fontNormal
set mn [menu $m.new]
$mn add command -label [::msgcat::mc "New file"] -command AddToProjDialog\
-font $fontNormal -accelerator "Ctrl+N"
$mn add command -label [::msgcat::mc "New project"] -command {NewProjDialog "new"}\
-font $fontNormal
$m add command -label [::msgcat::mc "Open"] -command {FileDialog open}\
-font $fontNormal -accelerator "Ctrl+O"        -state disable
$m add command -label [::msgcat::mc "Save"] -command {FileDialog save}\
-font $fontNormal -accelerator "Ctrl+S"
$m add command -label [::msgcat::mc "Save as"] -command {FileDialog save_as}\
-font $fontNormal -accelerator "Ctrl+A"
$m add command -label [::msgcat::mc "Save all"] -command {FileDialog save_all}\
-font $fontNormal
$m add command -label [::msgcat::mc "Close"] -command {FileDialog close}\
-font $fontNormal -accelerator "Ctrl+W"
$m add command -label [::msgcat::mc "Close all"] -command {FileDialog close_all}\
-font $fontNormal
$m add command -label [::msgcat::mc "Delete"] -command {FileDialog delete}\
-font $fontNormal -accelerator "Ctrl+D"
$m add separator
$m add command -label [::msgcat::mc "Compile file"] -command {MakeProj compile file} -font $fontNormal -accelerator "Ctrl+F8"
$m add command -label [::msgcat::mc "Run file"] -command {MakeProj run file} -font $fontNormal -accelerator "Ctrl+F9"
$m add separator
$m add command -label [::msgcat::mc "Print"] -command PrintDialog\
-font $fontNormal -accelerator "Ctrl+P"
$m add separator
$m add command -label [::msgcat::mc "Settings"] -command Settings -font $fontNormal
$m add separator
$m add command -label [::msgcat::mc "Exit"] -command Quit -font $fontNormal -accelerator "Ctrl+Q"

##.frmMenu 'Project' ##

proc GetProjMenu {m} {
    global fontNormal
    $m add command -label [::msgcat::mc "Project settings"] -command {NewProj edit $activeProject ""}\
    -font $fontNormal
    $m add separator
    $m add command -label [::msgcat::mc "Open project"] -command {OpenProj} -font $fontNormal
    $m add command -label [::msgcat::mc "New project"] -command {NewProjDialog new} -font $fontNormal
    $m add command -label [::msgcat::mc "Delete project"] -command DelProj -font $fontNormal
    $m add separator
    $m add command -label [::msgcat::mc "Add to project"] -command AddToProjDialog -font $fontNormal
    $m add command -label [::msgcat::mc "Delete from project"]\
    -command {FileDialog delete} -font $fontNormal
    $m add separator
    $m add command -label [::msgcat::mc "Make archive"] -command MakeTGZ -font $fontNormal -accelerator "F7"
    $m add command -label [::msgcat::mc "Make RPM"] -command MakeRPM -font $fontNormal -accelerator "F6"
    $m add separator
    $m add command -label [::msgcat::mc "Compile"] -command {MakeProj compile proj} -font $fontNormal -accelerator "F8"
    $m add command -label [::msgcat::mc "Run"] -command {MakeProj run proj} -font $fontNormal -accelerator "F9"
}

menubutton .frmMenu.mnuProj -text [::msgcat::mc "Project"] -menu .frmMenu.mnuProj.m -font $fontNormal
set m [menu .frmMenu.mnuProj.m]
GetProjMenu $m

##.frmMenu 'Edit' ##
menubutton .frmMenu.mnuEdit -text [::msgcat::mc "Edit"] -menu .frmMenu.mnuEdit.m -font $fontNormal
## BUILDING EDIT-MENU FOR MAIN AND POP-UP MENU ##
proc GetMenu {m} {
    global fontNormal fontBold imgDir
    $m add command -label [::msgcat::mc "Undo"] -font $fontNormal -accelerator "Ctrl+Z"\
    -state normal -command {
        set nb [$noteBook raise]
        if {$nb == "" || $nb == "newproj" || $nb == "about" || $nb == "debug"} {
            return
        }
        set nb "$noteBook.f$nb"
        $nb.text undo
        unset nb
    }
    $m add separator
    $m add command -label [::msgcat::mc "Procedure name complit"] -font $fontNormal -accelerator "Ctrl+J" -state normal\
    -command {
        set nb "$noteBook.f[$noteBook raise]"
        auto_completition_proc $nb.text
        unset nb
    }
    $m add separator
    $m add command -label [::msgcat::mc "Copy"] -font $fontNormal -accelerator "Ctrl+C"\
    -command {
        set nb "$noteBook.f[$noteBook raise]"
        tk_textCopy $nb.text
        unset nb
    }
    $m add command -label [::msgcat::mc "Paste"] -font $fontNormal -accelerator "Ctrl+V"\
    -command {
        set nb "$noteBook.f[$noteBook raise]"
        tk_textPaste $nb.text
        unset nb
    }
    $m add command -label [::msgcat::mc "Cut"] -font $fontNormal -accelerator "Ctrl+X"\
    -command {
        set nb "$noteBook.f[$noteBook raise]"
        tk_textCut $nb.text
        unset nb
    }
    $m add separator
    $m add command -label [::msgcat::mc "Select all"] -font $fontNormal -accelerator "Ctrl+/"\
    -command {
        set nb [$noteBook raise]
        if {$nb == "" || $nb == "newproj" || $nb == "about" || $nb == "debug"} {
            return
        }
        set nb "$noteBook.f$nb"
        SelectAll $nb.text
        unset nb
    }
    $m add separator
    $m add command -label [::msgcat::mc "Goto line"] -command GoToLine -font $fontNormal\
    -accelerator "Ctrl+G"
    $m add command -label [::msgcat::mc "Find"] -command Find -font $fontNormal -accelerator "Ctrl+F"
    $m add command -label [::msgcat::mc "Replace"] -command ReplaceDialog -font $fontNormal\
    -accelerator "Ctrl+R"
}
GetMenu [menu .frmMenu.mnuEdit.m];# main edit menu
GetMenu [menu .popMnuEdit] ;# pop-up edit menu

## VIEW MENU ##
menubutton .frmMenu.mnuView -text [::msgcat::mc "View"] -menu .frmMenu.mnuView.m -font $fontNormal
set m [menu .frmMenu.mnuView.m]
$m add checkbutton -label [::msgcat::mc "Toolbar"] -font $fontNormal -state normal\
-offvalue "No" -onvalue "Yes" -variable toolBar -command {ToolBar}
$m add command -label [::msgcat::mc "Split edit window"] -font $fontNormal -accelerator "F4" -state disable\
-command SplitWindow
$m add separator
$m add command -label [::msgcat::mc "Refresh"] -font $fontNormal -accelerator "F5" -state normal\
-command UpdateTree

##.frmMenu Settings ##
menubutton  .frmMenu.mnuCVS -text [::msgcat::mc "Modules"] -menu .frmMenu.mnuCVS.m \
-font $fontNormal -state normal
set m [menu .frmMenu.mnuCVS.m]
if {$module(tkcvs) != ""} {
    $m add command -label "TkCVS" -command {DoModule tkcvs} -font $fontNormal
}
if {$module(tkdiff) != ""} {
    $m add command -label "TkDIFF+" -command {DoModule tkdiff} -font $fontNormal
}
if {$module(tkregexp) != ""} {
    $m add command -label "TkREGEXP" -command {DoModule tkregexp} -font $fontNormal
}
if {$module(ctags) != ""} {
    $m add command -label "CTags" -font $fontNormal -command {
        DoModule ctags
        GetTagList [file join $workDir $activeProject.tags] ;# geting tag list
    }
}

menubutton  .frmMenu.mnuHelp  -text [::msgcat::mc "Help"] -menu .frmMenu.mnuHelp.m \
-underline 0 -font $fontNormal
set m [menu .frmMenu.mnuHelp.m]
$m  add  command  -label [::msgcat::mc "Help"]  -command  ShowHelp \
-accelerator F1 -font $fontNormal
$m add command -label [::msgcat::mc "About ..."] -command AboutDialog \
-font $fontNormal

pack .frmMenu.mnuFile .frmMenu.mnuProj .frmMenu.mnuEdit .frmMenu.mnuView .frmMenu.mnuCVS -side left
pack .frmMenu.mnuHelp -side right
## Bind command ##
bind . <F1> ShowHelp
bind . <F5> UpdateTree
bind . <F6> MakeRPM
bind . <F7> MakeTGZ
bind . <F8> {MakeProj compile proj}
bind . <Control-F8> {MakeProj compile file}
bind . <F9> {MakeProj run proj}
bind . <Control-F9> {MakeProj run file}
bind . <Control-ograve> AddToProjDialog
bind . <Control-n> AddToProjDialog
bind . <Control-ocircumflex> AddToProjDialog
bind . <Control-a> AddToProjDialog
bind . <Control-eacute> Quit
bind . <Control-q> Quit
bind . <Control-ccedilla> PrintDialog
bind . <Control-p> PrintDialog
## TOOLBAR ##
proc CreateToolBar {} {
    global toolBar fontBold noteBook tree imgDir
    if {$toolBar == "Yes"} {
        button .frmTool.btnNew -relief groove -font $fontBold -command {AddToProjDialog}
        button .frmTool.btnSave -relief groove -font $fontBold -command {FileDialog save}
        button .frmTool.btnSaveAs -relief groove -font $fontBold -command {FileDialog save_as}
        button .frmTool.btnSaveAll -relief groove -font $fontBold -command {FileDialog save_all}
        button .frmTool.btnClose -relief groove -font $fontBold -command {FileDialog close}
        button .frmTool.btnCopy -relief groove -font $fontBold -command {
            set nb "$noteBook.f[$noteBook raise]"
            tk_textCopy $nb.text
            unset nb
        }
        button .frmTool.btnPaste -relief groove -font $fontBold -command {
            set nb "$noteBook.f[$noteBook raise]"
            tk_textPaste $nb.text
            unset nb
        }
        button .frmTool.btnCut -relief groove -font $fontBold -command {
            set nb "$noteBook.f[$noteBook raise]"
            tk_textCut $nb.text
            unset nb
        }
        button .frmTool.btnDo -relief groove -font $fontBold -command {MakeProj run proj}
        button .frmTool.btnDoFile -relief groove -font $fontBold -command {MakeProj run file}
        button .frmTool.btnPrint -relief groove -font $fontBold -command PrintDialog -stat normal
        button .frmTool.btnTGZ -relief groove -font $fontBold -command MakeTGZ
        #button .frmTool.btnCvsIn -relief groove -font $fontBold -command CvsUpdate -state disable
        #button .frmTool.btnCvsOut -relief groove -font $fontBold -command CvsCommit -state disable
        button .frmTool.btnHelp -relief groove -font $fontBold -command ShowHelp
        
        #    
        image create photo imgNew -format gif -file [file join $imgDir new.gif]
        image create photo imgSave -format gif -file [file join $imgDir save.gif]
        image create photo imgSaveAs -format gif -file [file join $imgDir save_as.gif]
        image create photo imgSaveAll -format gif -file [file join $imgDir save_all.gif]
        image create photo imgClose -format gif -file [file join $imgDir close.gif]
        image create photo imgCopy -format gif -file [file join $imgDir copy.gif]
        image create photo imgPaste -format gif -file [file join $imgDir paste.gif]
        image create photo imgCut -format gif -file [file join $imgDir cut.gif]
        image create photo imgDo -format gif -file [file join $imgDir doit.gif]
        image create photo imgDoFile -format gif -file [file join $imgDir doit_file.gif]
        image create photo imgPrint -format gif -file [file join $imgDir printer.gif]
        image create photo imgTGZ -format gif -file [file join $imgDir archive.gif]
        #image create photo imgCvsIn -format gif -file [file join $imgDir cvs_in.gif]
        #image create photo imgCvsOut -format gif -file [file join $imgDir cvs_out.gif]
        image create photo imgHelp -format gif -file [file join $imgDir help.gif]
        .frmTool.btnNew configure -image imgNew
        .frmTool.btnSave configure -image imgSave
        .frmTool.btnSaveAs configure -image imgSaveAs
        .frmTool.btnSaveAll configure -image imgSaveAll
        .frmTool.btnClose configure -image imgClose
        .frmTool.btnCopy configure -image imgCopy
        .frmTool.btnPaste configure -image imgPaste
        .frmTool.btnCut configure -image imgCut
        .frmTool.btnDo configure -image imgDo
        .frmTool.btnDoFile configure -image imgDoFile
        .frmTool.btnPrint configure -image imgPrint
        #.frmTool.btnCvsIn configure -image imgCvsIn
        #.frmTool.btnCvsOut configure -image imgCvsOut
        .frmTool.btnTGZ configure -image imgTGZ
        .frmTool.btnHelp configure -image imgHelp
        pack .frmTool.btnNew .frmTool.btnSave .frmTool.btnSaveAs .frmTool.btnClose\
        .frmTool.btnSaveAll .frmTool.btnPrint .frmTool.btnCopy .frmTool.btnPaste\
        .frmTool.btnCut .frmTool.btnDo .frmTool.btnDoFile .frmTool.btnTGZ .frmTool.btnHelp\
        -side left -fill x ;#.frmTool.btnCvsIn .frmTool.btnCvsOut
        
        bind .frmTool.btnNew <Enter> {
            LabelUpdate .frmStatus.frmHelp.lblHelp [::msgcat::mc "Create new file"]
            #        bind .frmTool.btnNew <Enter> "balloon .frmTool.btnNew show \"Create new file\""
        }
        
        bind .frmTool.btnSave <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Save file"]}
        bind .frmTool.btnSaveAs <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Save file as"]}
        bind .frmTool.btnSaveAll <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Save all"]}
        bind .frmTool.btnClose <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Close"]}
        bind .frmTool.btnCopy <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Copy into clipboard"]}
        bind .frmTool.btnPaste <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Paste from clipboard"]}
        bind .frmTool.btnCut <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Cut into clipboard"]}
        bind .frmTool.btnDo <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Running project"]}
        bind .frmTool.btnDoFile <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Running file"]}
        bind .frmTool.btnPrint <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Print ..."]}
        bind .frmTool.btnTGZ <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Make TGZ"]}
        #bind .frmTool.btnCvsIn <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        #    [::msgcat::mc "CVS update"]}
        #bind .frmTool.btnCvsOut <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        #    [::msgcat::mc "CVS commit"]}
        bind .frmTool.btnHelp <Enter> {LabelUpdate .frmStatus.frmHelp.lblHelp\
        [::msgcat::mc "Help"]}
        
        bind .frmTool.btnNew <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnSave <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnSaveAs <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnSaveAll <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnClose <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnCopy <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnPaste <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnCut <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnDo <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnDoFile <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnPrint <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnTGZ <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        #bind .frmTool.btnCvsIn <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        #bind .frmTool.btnCvsOut <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
        bind .frmTool.btnHelp <Leave> {LabelUpdate .frmStatus.frmHelp.lblHelp ""}
    }
}
########## STATUS BAR ##########
set frm1 [frame .frmStatus.frmHelp]
set frm2 [frame .frmStatus.frmActive]
set frm3 [frame .frmStatus.frmProgress -relief sunken]
set frm4 [frame .frmStatus.frmLine]
set frm5 [frame .frmStatus.frmFile]
set frm6 [frame .frmStatus.frmOvwrt]
pack $frm1 $frm4 $frm6 $frm2 $frm5 -side left -fill x
pack $frm3 -side left -fill x -expand true
label $frm1.lblHelp -width 25 -relief sunken -font $fontNormal -anchor w
pack $frm1.lblHelp -fill x
label $frm4.lblLine -width 10 -relief sunken -font $fontNormal -anchor w
pack $frm4.lblLine -fill x
label $frm2.lblActive -width 25 -relief sunken -font $fontNormal -anchor center
pack $frm2.lblActive -fill x
label $frm3.lblProgress -relief sunken -font $fontNormal -anchor w
pack $frm3.lblProgress -fill x
label $frm5.lblFile -width 10 -relief sunken -font $fontNormal -anchor w 
pack $frm5.lblFile -fill x
label $frm6.lblOvwrt -width 10 -relief sunken -font $fontNormal -anchor center
pack $frm6.lblOvwrt -fill x

########## PROJECT-FILE-FUNCTION TREE ##################

set frmCat [frame .frmBody.frmCat -border 1 -relief sunken]
pack $frmCat -side left -fill y -fill both
set frmWork [frame .frmBody.frmWork -border 1 -relief sunken]
pack $frmWork -side left -fill both -expand true

## CREATE PANE ##
pane::create .frmBody.frmCat .frmBody.frmWork

set frmTree [ScrolledWindow $frmCat.frmTree]
global tree noteBook
set tree [Tree $frmTree.tree \
-relief sunken -borderwidth 1 -width 5 -height 5 -highlightthickness 1\
-redraw 0 -dropenabled 1 -dragenabled 1 -dragevent 3 \
-background "#d3d3d3" -selectbackground "#55c4d1" \
-droptypes {
    TREE_NODE    {copy {} move {} link {}}
    LISTBOX_ITEM {copy {} move {} link {}}
} -opencmd {TreeOpen} -closecmd  {TreeClose}]
$frmTree setwidget $tree
pack $frmTree -side top -fill both -expand true

$tree bindText  <Double-ButtonPress-1> "TreeDoubleClick [$tree selection get]"
$tree bindText  <ButtonPress-1> "TreeOneClick [$tree selection get]"
$tree bindImage  <Double-ButtonPress-1> "TreeDoubleClick [$tree selection get]"
$tree bindImage  <ButtonPress-1> "TreeOneClick [$tree selection get]"
$tree bindText <Shift-Button-1> {$tree selection add [$tree selection get]}
bind $frmTree.tree.c <Control-acircumflex> {FileDialog delete}
bind $frmTree.tree.c <Control-d> {FileDialog delete}
bind $frmTree.tree.c <Return> {
    set node [$tree selection get]
    TreeOneClick $node
    TreeDoubleClick $node
}

## POPUP FILE-MENU ##
set m .popupFile
menu $m -font $fontNormal                                                       
$m add command -label [::msgcat::mc "New"] -command AddToProjDialog\
-font $fontNormal -accelerator "Ctrl+N"
$m add command -label [::msgcat::mc "Open"] -command {FileDialog open}\
-font $fontNormal -accelerator "Ctrl+O"        -state disable
$m add command -label [::msgcat::mc "Save"] -command {FileDialog save}\
-font $fontNormal -accelerator "Ctrl+S"
$m add command -label [::msgcat::mc "Save as"] -command {FileDialog save_as}\
-font $fontNormal -accelerator "Ctrl+A"
$m add command -label [::msgcat::mc "Save all"] -command {FileDialog save_all}\
-font $fontNormal
$m add command -label [::msgcat::mc "Close"] -command {FileDialog close}\
-font $fontNormal -accelerator "Ctrl+W"
$m add command -label [::msgcat::mc "Close all"] -command {FileDialog close_all}\
-font $fontNormal
$m add command -label [::msgcat::mc "Delete"] -command {FileDialog delete}\
-font $fontNormal -accelerator "Ctrl+D"
$m add separator
$m add command -label [::msgcat::mc "Compile file"] -command {MakeProj compile file} -font $fontNormal -accelerator "Ctrl+F8"
$m add command -label [::msgcat::mc "Run file"] -command {MakeProj run file} -font $fontNormal -accelerator "Ctrl+F9"

## POPUP PROJECT-MENU ##
set m [menu .popupProj -font $fontNormal]
GetProjMenu $m


## TABS popups ##

set m .popupTabs
menu $m -font $fontNormal
$m add command -label [::msgcat::mc "Close"] -command {FileDialog close}\
-font $fontNormal -accelerator "Ctrl+W"
$m add command -label [::msgcat::mc "Close all"] -command {FileDialog close_all}\
-font $fontNormal


proc PopupMenuTab {menu x y} {
    tk_popup $menu $x $y
}



bind $frmTree.tree.c <Button-3> {catch [PopupMenuTree %X %Y]}

######### DEDERER: bind Wheel Scroll ##################
#$tree bindText  <Button-4> "$tree yview scroll -3 units ; break ;# "
#$tree bindText  <Button-5> "$tree yview scroll  3 units ; break ;# "
bind $frmTree.tree.c <Button-4> "$tree yview scroll -3 units"
bind $frmTree.tree.c <Button-5> "$tree yview scroll  3 units"
bind $frmTree.tree.c <Shift-Button-4> "$tree xview scroll -2 units"
bind $frmTree.tree.c <Shift-Button-5> "$tree xview scroll  2 units"

#################### WORKING AREA ####################
set noteBook [NoteBook $frmWork.noteBook -font $fontNormal -side top]
pack $noteBook -fill both -expand true -padx 2 -pady 2
$noteBook bindtabs  <ButtonRelease-1> PageRaise
$noteBook bindtabs <Button-3> {catch [PopupMenuTab .popupTabs %X %Y]}


#bind . <Control-udiaeresis> PageTab
#bind . <Control-M> PageTab

bind . <Control-Next> {PageTab 1}
bind . <Control-Prior> {PageTab -1}

##################################################
CreateToolBar
GetProj $tree
$tree configure -redraw 1
set activeProject ""
focus -force $tree



